Index: TWiki/UI/Register.pm
===================================================================
--- TWiki/UI/Register.pm	(revision 13172)
+++ TWiki/UI/Register.pm	(working copy)
@@ -64,7 +64,7 @@
 
 =pod
 
----++ StaticMethod register_cgi( $session )
+---++ StaticMethod register_cgi( )
 
 =register= command handler.
 This method is designed to be
@@ -73,10 +73,9 @@
 =cut
 
 sub register_cgi {
-    my $session = shift;
 
     # absolute URL context for email generation
-    $session->enterContext('absolute_urls');
+    $TWiki::SESSION->enterContext('absolute_urls');
 
     my $tempUserDir = $TWiki::cfg{RegistrationApprovals};
     my $needApproval = 0;
@@ -85,30 +84,30 @@
 
     # NB. bulkRegister invoked from ManageCgiScript.
 
-    my $action = $session->{cgiQuery}->param('action') || '';
+    my $action = $TWiki::SESSION->{cgiQuery}->param('action') || '';
 
     if ($action eq 'register') {
-      registerAndNext($session, $tempUserDir);
+        _registerAndNext($tempUserDir);
     }
     elsif ($action eq 'verify') {
-        verifyEmailAddress( $session, $tempUserDir );
+        verifyEmailAddress( $tempUserDir );
         if ($needApproval) {
             throw Error::Simple('Approval code has not been written!');
         }
-        finish( $session, $tempUserDir);
+        _finish( $tempUserDir);
     }
     elsif ($action eq 'resetPassword') {
         #SMELL - is this still called here, or only by passwd? 
-        resetPassword( $session );
+        _resetPassword( );
     }
     elsif ($action eq 'approve') {
-        finish($session, $tempUserDir );
+        _finish($tempUserDir );
     }
     else {
-      registerAndNext($session, $tempUserDir);
+        _registerAndNext($TWiki::SESSION, $tempUserDir);
     }
 
-    $session->leaveContext('absolute_urls');
+    $TWiki::SESSION->leaveContext('absolute_urls');
 
     # Output of register:
     #    UnsavedUser, accessible by username.$verificationCode
@@ -125,7 +124,7 @@
 
 =pod
 
----++ StaticMethod passwd_cgi( $session )
+---++ StaticMethod passwd_cgi()
 
 =passwd= command handler.
 This method is designed to be
@@ -134,26 +133,24 @@
 =cut
 
 sub passwd_cgi {
-    my $session = shift;
+    my $action = $TWiki::SESSION->{cgiQuery}->param('action');
 
-    my $action = $session->{cgiQuery}->param('action');
-
     # absolute URL context for email generation
-    $session->enterContext('absolute_urls');
+    $TWiki::SESSION->enterContext('absolute_urls');
 
     if( $action eq 'changePassword' ) {
-        changePassword( $session );
+        changePassword( $TWiki::SESSION );
     }
     elsif ( $action eq 'resetPassword' ) {
-        resetPassword( $session );
+        _resetPassword( );
     }
     else {
         throw TWiki::OopsException( 'attention',
-                                    web => $session->{webName},
-                                    topic => $session->{topicName},
+                                    web => $TWiki::SESSION->{webName},
+                                    topic => $TWiki::SESSION->{topicName},
                                     def => 'missing_action' );
     }
-    $session->leaveContext('absolute_urls');
+    $TWiki::SESSION->leaveContext('absolute_urls');
 }
 
 # TODO: S&R {form} with {ordered}
@@ -179,7 +176,7 @@
 
 =pod
 
----++ StaticMethod bulkRegister($session)
+---++ StaticMethod bulkRegister()
 
   Called by ManageCgiScript::bulkRegister (requires authentication) with topic = the page with the entries on it.
    1 Makes sure you are an admin user ;)
@@ -193,16 +190,14 @@
 =cut
 
 sub bulkRegister {
-    my $session = shift;
-
-    my $user = $session->{user};
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
+    my $user = $TWiki::SESSION->{user};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
     my $userweb = $TWiki::cfg{UsersWebName};
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
 
     # absolute URL context for email generation
-    $session->enterContext('absolute_urls');
+    $TWiki::SESSION->enterContext('absolute_urls');
 
     my $settings = {};
     $settings->{doOverwriteTopics} =
@@ -219,7 +214,7 @@
 
     #-- Read the topic containing a table of people to be registered
 
-    my ($meta, $text) = $session->{store}->readTopic( undef,
+    my ($meta, $text) = $TWiki::STORE->readTopic( undef,
                                                       $web, $topic, undef );
     my %data;
     ( $settings->{fieldNames}, %data ) =
@@ -239,9 +234,9 @@
         next ROW if (length($row->{WikiName}) == 0);
 
         try {
-            _validateRegistration( $session, $row, $query, $topic, 0 );
+            _validateRegistration( $row, $query, $topic, 0 );
             my ($userTopic, $uLog) =
-              _registerSingleBulkUser($session, $row, $settings );
+              _registerSingleBulkUser($row, $settings );
             if( $userTopic ) {
                 $log .= "\n---+++ ". $row->{WikiName}."\n";
                 $log .= $b.' Added to users topic '.$userTopic.":\n".
@@ -250,7 +245,7 @@
             }
         } catch TWiki::OopsException with {
             my $e = shift;
-            $log .= $e->stringify( $session )."\n";
+            $log .= $e->stringify( $TWiki::SESSION )."\n";
         };
     }
 
@@ -259,15 +254,15 @@
 
     my $logWeb;
     my $logTopic =  $query->param('LogTopic') || $topic.'Result';
-    ( $logWeb, $logTopic ) = $session->normalizeWebTopicName( '', $logTopic );
+    ( $logWeb, $logTopic ) = $TWiki::SESSION->normalizeWebTopicName( '', $logTopic );
 
     #-- Save the LogFile as designated, link back to the source topic 
     $meta->put( 'TOPICPARENT', { name => $web.'.'.$topic } );
-    my $err = $session->{store}->saveTopic($user, $logWeb, $logTopic, $log, $meta );
+    my $err = $TWiki::STORE->saveTopic($user, $logWeb, $logTopic, $log, $meta );
 
-    $session->leaveContext('absolute_urls');
+    $TWiki::SESSION->leaveContext('absolute_urls');
 
-    $session->redirect($session->getScriptUrl( 1, 'view', $web, $logTopic ));
+    $TWiki::SESSION->redirect($TWiki::SESSION->getScriptUrl( 1, 'view', $web, $logTopic ));
 }
 
 #    Process a single user, parameters passed as a hash
@@ -281,7 +276,7 @@
 # SMELL could be made much more efficient if needed, as calls to addUserToMapping()
 # are quite expensive when doing 300 in succession!
 sub _registerSingleBulkUser {
-    my ($session, $row, $settings) = @_;
+    my ($row, $settings) = @_;
     ASSERT( $row ) if DEBUG;
     ASSERT( $settings->{fieldNames} ) if DEBUG;
     my $fieldNames = $settings->{fieldNames};
@@ -318,21 +313,21 @@
     #-- Generation of the page is done from the {form} subhash, so align the two
     $row->{form} = _makeFormFieldOrderMatch( $fieldNames, $row);
 
-    my $passResult = _addUserToPasswordSystem( $session, $row );
+    my $passResult = _addUserToPasswordSystem( $row );
     $log .= $b.' Password set '.($passResult?'OK':'FAILED')."\n";
     #TODO: need a path for if it doesn't succeed.
 
-    $session->writeLog('bulkregister', $row->{webName}.'.'.$row->{WikiName},
+    $TWiki::SESSION->writeLog('bulkregister', $row->{webName}.'.'.$row->{WikiName},
                        $row->{Email}, $row->{WikiName} );
 
-    my $user = $session->{users}->findUser( $row->{LoginName},
-                                            $row->{WikiName} );
+    my $user = $TWiki::USERS->findUser( $row->{LoginName},
+                                        $row->{WikiName} );
 
     my $userTopic =
-      $session->{users}->addUserToMapping( $user, $session->{user} );
+      $TWiki::USERS->addUserToMapping( $user, $TWiki::SESSION->{user} );
 
-    if( $doOverwriteTopics or !$session->{store}->topicExists( $row->{webName}, $row->{WikiName} ) ) {
-        $log .= _createUserTopic($session, 'NewUserTemplate', $row);
+    if( $doOverwriteTopics or !$TWiki::STORE->topicExists( $row->{webName}, $row->{WikiName} ) ) {
+        $log .= _createUserTopic('NewUserTemplate', $row);
     } else {
         $log .= $b.' Not writing topic '.$row->{WikiName}."\n";
 	}
@@ -340,7 +335,7 @@
 
     #if ($TWiki::cfg{EmailUserDetails}) {
         # If you want it, write it.
-        # _sendEmail($session, 'registernotifybulk', $data );
+        # _sendEmail('registernotifybulk', $data );
     #    $log .= $b.' Password email disabled\n';
     #}
     return ($userTopic, $log);
@@ -373,31 +368,23 @@
     return \@form;
 }
 
-=pod
-
----++ StaticMethod registerAndNext($session, $tempUserDir) 
-
-This is called when action = register or action = ""
-
-It calls register and either Verify or Finish.
-
-Hopefully we will get workflow integrated and rewrite this to be table driven
-
-=cut
-
-sub registerAndNext {
-  my ($session, $tempUserDir) = @_;
-  register( $session );
+# _registerAndNext($tempUserDir)
+# This is called when action = register or action = ""
+# It calls register and either Verify or Finish.
+# Hopefully we will get workflow integrated and rewrite this to be table driven
+sub _registerAndNext {
+  my ($tempUserDir) = @_;
+  register();
   if ($TWiki::cfg{Register}{NeedVerification}) {
-     _requireVerification($session, $tempUserDir);
+     _requireVerification($tempUserDir);
   } else {
-     finish($session);
+     _finish( $tempUserDir );
   }
 }
 
 =pod
 
----++ StaticMethod register($session)
+---++ StaticMethod register()
 
 This is called through: TWikiRegistration -> RegisterCgiScript -> here
 
@@ -407,18 +394,16 @@
 =cut
 
 sub register {
-    my( $session ) = @_;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
 
-    my $query = $session->{cgiQuery};
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
-
     my $data = _getDataFromQuery( $query, $query->param() );
 
     $data->{webName} = $web;
     $data->{debug} = 1;
 
-    _validateRegistration( $session, $data, $query, $topic, 1 );
+    _validateRegistration( $data, $query, $topic, 1 );
 }
 
 #   1 generates a activation password
@@ -426,11 +411,11 @@
 #   3 sends them a 'registerconfirm' email.
 #   4 redirects browser to 'regconfirm'
 sub _requireVerification {
-    my ($session, $tmpDir) = @_;
+    my ($tmpDir) = @_;
 
-    my $query = $session->{cgiQuery};
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
 
     my $data = _getDataFromQuery( $query, $query->param() );
     $data->{webName} = $web;
@@ -439,11 +424,11 @@
       $data->{WikiName}.'.'.TWiki::User::randomPassword();
     _putRegDetailsByCode( $data, $tmpDir );
 
-    $session->writeLog(
+    $TWiki::SESSION->writeLog(
         'regstart', $TWiki::cfg{UsersWebName}.'.'.$data->{WikiName},
         $data->{Email}, $data->{WikiName} );
 
-    my $err = _sendEmail( $session, 'registerconfirm', $data );
+    my $err = _sendEmail( 'registerconfirm', $data );
     my $em = TWiki::entityEncode( $data->{Email} );
 
     if($err) {
@@ -462,22 +447,18 @@
                                 params => [ $em ] );
 }
 
-=pod
+# _resetPassword()
+#
+# Generates a password. Mails it to them and asks them to change it. Entry
+# point intended to be called from TWiki::UI::run
+#
 
----++ StaticMethod resetPassword($session)
+sub _resetPassword {
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
+    my $user = $TWiki::SESSION->{user};
 
-Generates a password. Mails it to them and asks them to change it. Entry
-point intended to be called from TWiki::UI::run
-
-=cut
-
-sub resetPassword {
-    my $session = shift;
-    my $query = $session->{cgiQuery};
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
-    my $user = $session->{user};
-
     my @userNames = $query->param( 'LoginName' ) ;
     unless( @userNames ) {
         throw TWiki::OopsException( 'attention',
@@ -508,7 +489,7 @@
     my $good = 1;
     foreach my $userName (@userNames) {
         $good = $good &&
-          _resetUsersPassword( $session, $userName, $introduction, \$message );
+          _resetUsersPassword( $userName, $introduction, \$message );
     }
 
     my $action = '';
@@ -534,20 +515,20 @@
 
 # return status
 sub _resetUsersPassword {
-    my( $session, $userName, $introduction, $pMess ) = @_;
+    my( $userName, $introduction, $pMess ) = @_;
 
-    my $user = $session->{users}->findUser( $userName, undef, 1);
+    my $user = $TWiki::USERS->findUser( $userName, undef, 1);
     unless( $user ) {
         # couldn't work out who they are, its neither loginName nor
         # wikiName.
-        $$pMess .= $session->inlineAlert( 'alerts', 'bad_user', $userName );
+        $$pMess .= $TWiki::SESSION->inlineAlert( 'alerts', 'bad_user', $userName );
         return 0;
     }
 
     my $message = '';
     unless( $user->passwordExists() ) {
         # Not an error.
-        $$pMess .= $session->inlineAlert( 'alerts', 'missing_user',
+        $$pMess .= $TWiki::SESSION->inlineAlert( 'alerts', 'missing_user',
                                           $user->wikiName());
     }
 
@@ -555,12 +536,11 @@
 
     my @em = $user->emails();
     if (!scalar(@em)) {
-        $$pMess .= $session->inlineAlert( 'alerts', 'no_email_for',
+        $$pMess .= $TWiki::SESSION->inlineAlert( 'alerts', 'no_email_for',
                                           $user->wikiName());
     } else {
         foreach my $email ( @em ) {
             my $err = _sendEmail(
-                $session,
                 'mailresetpassword',
                 {
                     webName => $TWiki::cfg{UsersWebName},
@@ -573,12 +553,12 @@
                 } );
 
             if( $err ) {
-                $$pMess .= $session->inlineAlert( 'alerts', 'generic', $err );
+                $$pMess .= $TWiki::SESSION->inlineAlert( 'alerts', 'generic', $err );
             }
         }
     }
 
-    $$pMess .= $session->inlineAlert( 'alerts',
+    $$pMess .= $TWiki::SESSION->inlineAlert( 'alerts',
                                       'new_sys_pass',
                                       $user->login(),
                                       $user->wikiName() );
@@ -588,7 +568,7 @@
 
 =pod
 
----++ StaticMethod changePassword( $session )
+---++ StaticMethod changePassword()
 
 Change the user's password and/or email. Details of the user and password
 are passed in CGI parameters.
@@ -606,13 +586,11 @@
 =cut
 
 sub changePassword {
-    my $session = shift;
+    my $topic = $TWiki::SESSION->{topicName};
+    my $webName = $TWiki::SESSION->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $requestUser = $TWiki::SESSION->{user};
 
-    my $topic = $session->{topicName};
-    my $webName = $session->{webName};
-    my $query = $session->{cgiQuery};
-    my $requestUser = $session->{user};
-
     my $oldpassword = $query->param( 'oldpassword' );
     my $username = $query->param( 'username' );
     my $passwordA = $query->param( 'password' );
@@ -630,7 +608,7 @@
                                     params => [ 'username' ] );
     }
 
-    my $user = $session->{users}->findUser( $username );
+    my $user = $TWiki::USERS->findUser( $username );
 
     unless ($user) {
         throw TWiki::OopsException( 'attention',
@@ -692,13 +670,13 @@
         }
         my $e = $user->changePassword( $oldpassword, $passwordA );
         if( $e ) {
-            $session->writeWarning('password could not be changed: '.$e);
+            $TWiki::SESSION->writeWarning('password could not be changed: '.$e);
             throw TWiki::OopsException( 'attention',
                                         web => $webName,
                                         topic => $topic,
                                         def => 'password_not_changed');
         } else {
-            $session->writeLog('changepasswd', $user->wikiName());
+            $TWiki::SESSION->writeLog('changepasswd', $user->wikiName());
         }
         # OK - password changed
         throw TWiki::OopsException( 'attention',
@@ -716,7 +694,7 @@
 
 =pod
 
----++ StaticMethod verifyEmailAddress($session, $tempUserDir)
+---++ StaticMethod verifyEmailAddress($tempUserDir)
 
 This is called: on receipt of the activation password -> RegisterCgiScript -> here
    1 calls _reloadUserContext(activation password)
@@ -727,9 +705,9 @@
 =cut
 
 sub verifyEmailAddress {
-    my( $session, $tempUserDir ) = @_;
+    my( $tempUserDir ) = @_;
 
-    my $code = $session->{cgiQuery}->param('code');
+    my $code = $TWiki::SESSION->{cgiQuery}->param('code');
     unless( $code ) {
         throw Error::Simple( 'verifyEmailAddress: no verification code!');
     }
@@ -739,16 +717,16 @@
         throw Error::Simple( 'verifyEmailAddress: no email address!');
     }
 
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
 
-    #    $this->{session}->writeLog('verifyuser', $loginName, $userName);
+    #    $TWiki::SESSION->writeLog('verifyuser', $loginName, $userName);
 
 }
 
 =pod
 
----++ StaticMethod finish
+---++ StaticMethod _finish
 
 Presently this is called in RegisterCgiScript directly after a call to verify. The separation is intended for the RegistrationApprovals functionality
    1 calls _reloadUserContext (throws oops if appropriate)
@@ -764,12 +742,12 @@
 
 =cut
 
-sub finish {
-    my( $session, $tempUserDir) = @_;
+sub _finish {
+    my( $tempUserDir) = @_;
 
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
-    my $query = $session->{cgiQuery};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
+    my $query = $TWiki::SESSION->{cgiQuery};
 	my $code = $query->param('code');
 
 	my $data;
@@ -785,7 +763,7 @@
         throw Error::Simple( 'no WikiName after reload');
     }
 
-    my $success = _addUserToPasswordSystem( $session, $data );
+    my $success = _addUserToPasswordSystem( $data );
     # SMELL - error condition? surely need a way to flag an error?
     unless ( $success ) {
         throw TWiki::OopsException( 'attention',
@@ -796,43 +774,43 @@
     }
 
     # Plugin callback to set cookies.
-    $session->{plugins}->registrationHandler( $data->{WebName},
+    $TWiki::PLUGINS->registrationHandler( $data->{WebName},
                                               $data->{WikiName},
                                               $data->{LoginName} );
 
     # let the client session know that we're logged in. (This probably
     # eliminates the need for the registrationHandler call above,
     # but we'll leave them both in here for now.)
-    $session->{loginManager}->userLoggedIn( $data->{LoginName}, $data->{WikiName} );
+    $TWiki::LOGIN->userLoggedIn( $data->{LoginName}, $data->{WikiName} );
 
     # add user to TWikiUsers topic
-    my $user = $session->{users}->createUser( $data->{LoginName},
+    my $user = $TWiki::USERS->createUser( $data->{LoginName},
                                               $data->{WikiName} );
 
-    my $agent = $session->{users}->findUser( $twikiRegistrationAgent,
+    my $agent = $TWiki::USERS->findUser( $twikiRegistrationAgent,
                                              $twikiRegistrationAgent);
 
-    my $userTopic = $session->{users}->addUserToMapping( $user, $agent);
+    my $userTopic = $TWiki::USERS->addUserToMapping( $user, $agent);
 
     # inform user and admin about the registration.
-    my $status = _emailRegistrationConfirmations( $session, $data );
+    my $status = _emailRegistrationConfirmations( $data );
 
-    my $log = _createUserTopic($session, 'NewUserTemplate', $data);
+    my $log = _createUserTopic('NewUserTemplate', $data);
 
     $user->setEmails( $data->{Email} );
 
     # write log entry
     if ($TWiki::cfg{Log}{register}) {
-        $session->writeLog(
+        $TWiki::SESSION->writeLog(
             'register', $TWiki::cfg{UsersWebName}.'.'.$data->{WikiName},
             $data->{Email}, $data->{WikiName} );
     }
 
     if( $status ) {
-        $status = $session->{i18n}->maketext(
+        $status = $TWiki::I18N->maketext(
             'Warning: Could not send confirmation email')."\n\n$status";
     } else {
-        $status = $session->{i18n}->maketext(
+        $status = $TWiki::I18N->maketext(
             'A confirmation e-mail has been sent to [_1]',
             TWiki::entityEncode( $data->{Email} ));
     }
@@ -852,8 +830,8 @@
 #I use RegistrationHandler::register to prevent certain fields (like password) 
 #appearing in the homepage and to fetch photos into the topic
 sub _createUserTopic {
-    my ($session, $template, $row) = @_;
-    my ( $meta, $text ) = TWiki::UI::readTemplateTopic($session, $template);
+    my ($template, $row) = @_;
+    my ( $meta, $text ) = TWiki::UI::readTemplateTopic($template);
     my $log = $b.' Writing topic '.$TWiki::cfg{UsersWebName}.'.'.$row->{WikiName}."\n".
       $b2.' RegistrationHandler: ';
     my $regLog = $text;
@@ -861,7 +839,7 @@
     $log .= $b2.' '.
       join( "\n".$b2.' ',
             split( /\r?\n/,
-                   _writeRegistrationDetailsToTopic( $session, $row,
+                   _writeRegistrationDetailsToTopic( $row,
                                                      $meta, $text )))."\n";
     return $log;
 }
@@ -872,7 +850,7 @@
 #Returns 'BulletFields' or 'FormFields' depending on what it chose.
 #
 sub _writeRegistrationDetailsToTopic {
-    my ($session, $data, $meta, $text) = @_;
+    my ($data, $meta, $text) = @_;
 
     ASSERT($data->{WikiName}) if DEBUG;
 
@@ -888,7 +866,7 @@
     my $form = $meta->get( 'FORM' );
     if( $form ) {
         ( $meta, $addText ) =
-          _populateUserTopicForm( $session, $form->{name}, $meta, $data );
+          _populateUserTopicForm( $form->{name}, $meta, $data );
         $log = 'Using Form Fields';
     } else {
         $addText = _getRegFormAsTopicContent( $data );
@@ -897,26 +875,26 @@
     $text = $before . $addText . $after;
 
     my $userName = $data->{remoteUser} || $data->{WikiName};
-    my $user = $session->{users}->findUser( $userName );
-    $text = $session->expandVariablesOnTopicCreation( $text, $user );
+    my $user = $TWiki::USERS->findUser( $userName );
+    $text = $TWiki::SESSION->expandVariablesOnTopicCreation( $text, $user );
 
     $meta->put( 'TOPICPARENT', { 'name' => $TWiki::cfg{UsersTopicName}} );
 
-    my $agent = $session->{users}->findUser( $twikiRegistrationAgent,
+    my $agent = $TWiki::USERS->findUser( $twikiRegistrationAgent,
                                              $twikiRegistrationAgent);
 
-    $session->{store}->saveTopic($agent, $TWiki::cfg{UsersWebName},
+    $TWiki::STORE->saveTopic($agent, $TWiki::cfg{UsersWebName},
                                  $data->{WikiName}, $text, $meta );
     return $log;
 }
 
 # Puts form fields into the topic form
 sub _populateUserTopicForm {
-    my ( $session, $formName, $meta, $data ) = @_;
+    my ( $formName, $meta, $data ) = @_;
 
     my %inform;
     my $form =
-      new TWiki::Form( $session, $TWiki::cfg{UsersWebName}, $formName );
+      new TWiki::Form( $TWiki::SESSION, $TWiki::cfg{UsersWebName}, $formName );
     foreach my $field ( @{$form->{fields}} ) {
         foreach my $fd (@{$data->{form}}) {
             next unless $fd->{name} eq $field->{name};
@@ -956,32 +934,30 @@
 #emails both the admin 'registernotifyadmin' and the user 'registernotify', 
 #in separate emails so they both get targeted information (and no password to the admin).
 sub _emailRegistrationConfirmations {
-    my ( $session, $data ) = @_;
+    my ( $data ) = @_;
 
-    my $skin = $session->getSkin();
+    my $skin = $TWiki::SESSION->getSkin();
     my $template =
-      $session->{templates}->readTemplate( 'registernotify', $skin );
+      $TWiki::TEMPLATES->readTemplate( 'registernotify', $skin );
     my $email =
-      _buildConfirmationEmail( $session,
-                               $data,
+      _buildConfirmationEmail( $data,
                                $template,
                                $TWiki::cfg{Register}{HidePasswd}
                              );
 
-    my $warnings = $session->{net}->sendEmail( $email);
+    my $warnings = $TWiki::NET->sendEmail( $email);
 
     $template =
-      $session->{templates}->readTemplate( 'registernotifyadmin', $skin );
+      $TWiki::TEMPLATES->readTemplate( 'registernotifyadmin', $skin );
     $email =
-      _buildConfirmationEmail( $session,
-                               $data,
+      _buildConfirmationEmail( $data,
                                $template,
                                1 );
 
-    my $err = $session->{net}->sendEmail( $email );
+    my $err = $TWiki::NET->sendEmail( $email );
     if( $err ) {
         # don't tell the user about this one
-        $session->writeWarning('Could not confirm registration: '.$err);
+        $TWiki::SESSION->writeWarning('Could not confirm registration: '.$err);
     }
 
     return $warnings;
@@ -989,7 +965,7 @@
 
 #The template dictates the to: field
 sub _buildConfirmationEmail {
-    my ( $session, $data, $templateText, $hidePassword ) = @_;
+    my ( $data, $templateText, $hidePassword ) = @_;
 
     $data->{Name} ||= $data->{WikiName};
     $templateText =~ s/%FIRSTLASTNAME%/$data->{Name}/go;
@@ -1008,7 +984,7 @@
         }
     }
     $templateText = $before.($after||'');
-    $templateText = $session->handleCommonTags(
+    $templateText = $TWiki::SESSION->handleCommonTags(
         $templateText, $TWiki::cfg{UsersWebName}, $data->{WikiName} );
     $templateText =~ s/( ?) *<\/?(nop|noautolink)\/?>\n?/$1/gois;
     # remove <nop> and <noautolink> tags
@@ -1018,11 +994,11 @@
 
 # Throws an Oops exception if there is a problem.
 sub _validateRegistration {
-    my ( $session, $data, $query, $topic, $requireForm ) = @_;
+    my ( $data, $query, $topic, $requireForm ) = @_;
 
     # DELETED CHECK: check for wikiName field.
 
-    if($session->{store}->topicExists( $TWiki::cfg{UsersWebName}, $data->{WikiName} )) {
+    if($TWiki::STORE->topicExists( $TWiki::cfg{UsersWebName}, $data->{WikiName} )) {
         throw TWiki::OopsException( 'attention',
                                     web => $data->{webName},
                                     topic => $topic,
@@ -1039,7 +1015,7 @@
                                     params => [ $data->{LoginName} ] );
     }
 
-    if ($session->{users}->lookupLoginName($data->{LoginName})) {
+    if ($TWiki::USERS->lookupLoginName($data->{LoginName})) {
         throw TWiki::OopsException( 'attention',
                                     web => $data->{webName},
                                     topic => $topic,
@@ -1047,7 +1023,7 @@
                                     params => [ $data->{LoginName},  ] );
     }
 
-    my $user = $session->{users}->findUser( $data->{LoginName}, undef, 1 );
+    my $user = $TWiki::USERS->findUser( $data->{LoginName}, undef, 1 );
     if ( $user && $user->passwordExists() ) {
         throw TWiki::OopsException( 'attention',
                                     web => $data->{webName},
@@ -1133,9 +1109,9 @@
 
 #SMELL - when should they get notified of the password?
 sub _addUserToPasswordSystem {
-    my( $session, $userRow ) = @_;
+    my( $userRow ) = @_;
 
-    my $user = $session->{users}->findUser($userRow->{LoginName}, $userRow->{WikiName});
+    my $user = $TWiki::USERS->findUser($userRow->{LoginName}, $userRow->{WikiName});
     if ($user && $user->passwordExists()) {
         unless( $user->checkPassword( $userRow->{Password} )) {
             throw Error::Simple("New password did not match existing password for this user");
@@ -1147,13 +1123,13 @@
     my $success;
     if ($userRow->{CryptPassword})  {
         throw Error::Simple( 'No API to install crypted password' );
-        #	$success = $session->{users}->installCryptedPassword($userRow->{LoginName},
+        #	$success = $TWiki::USERS->installCryptedPassword($userRow->{LoginName},
         #						   $userRow->{CryptPassword});
     }
     my $password = $userRow->{Password};
     unless ($password) {
         $password = TWiki::User::randomPassword();
-        $session->writeWarning('No password specified for '.$userRow->{LoginName}.' - using random='.$password);
+        $TWiki::SESSION->writeWarning('No password specified for '.$userRow->{LoginName}.' - using random='.$password);
     }
     $user->addPassword( $password );
     return 1;
@@ -1161,9 +1137,9 @@
 
 # sends $p->{template} to $p->{Email} with a bunch of substitutions.
 sub _sendEmail {
-    my( $session, $template, $p ) = @_;
+    my( $template, $p ) = @_;
 
-    my $text = $session->{templates}->readTemplate( $template );
+    my $text = $TWiki::TEMPLATES->readTemplate( $template );
     $p->{Introduction} ||= '';
     $p->{Name} ||= $p->{WikiName};
     $text =~ s/%LOGINNAME%/$p->{LoginName}/geo;
@@ -1173,10 +1149,10 @@
     $text =~ s/%INTRODUCTION%/$p->{Introduction}/go;
     $text =~ s/%VERIFICATIONCODE%/$p->{VerificationCode}/go;
     $text =~ s/%PASSWORD%/$p->{PasswordA}/go;
-    $text = $session->handleCommonTags(
+    $text = $TWiki::SESSION->handleCommonTags(
         $text, $TWiki::cfg{UsersWebName}, $p->{WikiName} );
 
-    return $session->{net}->sendEmail($text);
+    return $TWiki::NET->sendEmail($text);
 }
 
 # | In | reference to the users data structure |
